// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package accessanalyzer provides the client and types for making API
// requests to Access Analyzer.
//
// Identity and Access Management Access Analyzer helps you to set, verify,
// and refine your IAM policies by providing a suite of capabilities. Its features
// include findings for external and unused access, basic and custom policy
// checks for validating policies, and policy generation to generate fine-grained
// policies. To start using IAM Access Analyzer to identify external or unused
// access, you first need to create an analyzer.
//
// External access analyzers help identify potential risks of accessing resources
// by enabling you to identify any resource policies that grant access to an
// external principal. It does this by using logic-based reasoning to analyze
// resource-based policies in your Amazon Web Services environment. An external
// principal can be another Amazon Web Services account, a root user, an IAM
// user or role, a federated user, an Amazon Web Services service, or an anonymous
// user. You can also use IAM Access Analyzer to preview public and cross-account
// access to your resources before deploying permissions changes.
//
// Unused access analyzers help identify potential identity access risks by
// enabling you to identify unused IAM roles, unused access keys, unused console
// passwords, and IAM principals with unused service and action-level permissions.
//
// Beyond findings, IAM Access Analyzer provides basic and custom policy checks
// to validate IAM policies before deploying permissions changes. You can use
// policy generation to refine permissions by attaching a policy generated using
// access activity logged in CloudTrail logs.
//
// This guide describes the IAM Access Analyzer operations that you can call
// programmatically. For general information about IAM Access Analyzer, see
// Identity and Access Management Access Analyzer (https://docs.aws.amazon.com/IAM/latest/UserGuide/what-is-access-analyzer.html)
// in the IAM User Guide.
//
// See https://docs.aws.amazon.com/goto/WebAPI/accessanalyzer-2019-11-01 for more information on this service.
//
// See accessanalyzer package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/accessanalyzer/
//
// # Using the Client
//
// To contact Access Analyzer with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Access Analyzer client AccessAnalyzer for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/accessanalyzer/#New
package accessanalyzer
