// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package codestarconnections

import (
	"github.com/aws/aws-sdk-go/private/protocol"
)

const (

	// ErrCodeAccessDeniedException for service response error code
	// "AccessDeniedException".
	//
	// You do not have sufficient access to perform this action.
	ErrCodeAccessDeniedException = "AccessDeniedException"

	// ErrCodeConcurrentModificationException for service response error code
	// "ConcurrentModificationException".
	//
	// Exception thrown as a result of concurrent modification to an application.
	// For example, two individuals attempting to edit the same application at the
	// same time.
	ErrCodeConcurrentModificationException = "ConcurrentModificationException"

	// ErrCodeConditionalCheckFailedException for service response error code
	// "ConditionalCheckFailedException".
	//
	// The conditional check failed. Try again later.
	ErrCodeConditionalCheckFailedException = "ConditionalCheckFailedException"

	// ErrCodeConflictException for service response error code
	// "ConflictException".
	//
	// Two conflicting operations have been made on the same resource.
	ErrCodeConflictException = "ConflictException"

	// ErrCodeInternalServerException for service response error code
	// "InternalServerException".
	//
	// Received an internal server exception. Try again later.
	ErrCodeInternalServerException = "InternalServerException"

	// ErrCodeInvalidInputException for service response error code
	// "InvalidInputException".
	//
	// The input is not valid. Verify that the action is typed correctly.
	ErrCodeInvalidInputException = "InvalidInputException"

	// ErrCodeLimitExceededException for service response error code
	// "LimitExceededException".
	//
	// Exceeded the maximum limit for connections.
	ErrCodeLimitExceededException = "LimitExceededException"

	// ErrCodeResourceAlreadyExistsException for service response error code
	// "ResourceAlreadyExistsException".
	//
	// Unable to create resource. Resource already exists.
	ErrCodeResourceAlreadyExistsException = "ResourceAlreadyExistsException"

	// ErrCodeResourceNotFoundException for service response error code
	// "ResourceNotFoundException".
	//
	// Resource not found. Verify the connection resource ARN and try again.
	ErrCodeResourceNotFoundException = "ResourceNotFoundException"

	// ErrCodeResourceUnavailableException for service response error code
	// "ResourceUnavailableException".
	//
	// Resource not found. Verify the ARN for the host resource and try again.
	ErrCodeResourceUnavailableException = "ResourceUnavailableException"

	// ErrCodeRetryLatestCommitFailedException for service response error code
	// "RetryLatestCommitFailedException".
	//
	// Retrying the latest commit failed. Try again later.
	ErrCodeRetryLatestCommitFailedException = "RetryLatestCommitFailedException"

	// ErrCodeSyncBlockerDoesNotExistException for service response error code
	// "SyncBlockerDoesNotExistException".
	//
	// Unable to continue. The sync blocker does not exist.
	ErrCodeSyncBlockerDoesNotExistException = "SyncBlockerDoesNotExistException"

	// ErrCodeSyncConfigurationStillExistsException for service response error code
	// "SyncConfigurationStillExistsException".
	//
	// Unable to continue. The sync blocker still exists.
	ErrCodeSyncConfigurationStillExistsException = "SyncConfigurationStillExistsException"

	// ErrCodeThrottlingException for service response error code
	// "ThrottlingException".
	//
	// The request was denied due to request throttling.
	ErrCodeThrottlingException = "ThrottlingException"

	// ErrCodeUnsupportedOperationException for service response error code
	// "UnsupportedOperationException".
	//
	// The operation is not supported. Check the connection status and try again.
	ErrCodeUnsupportedOperationException = "UnsupportedOperationException"

	// ErrCodeUnsupportedProviderTypeException for service response error code
	// "UnsupportedProviderTypeException".
	//
	// The specified provider type is not supported for connections.
	ErrCodeUnsupportedProviderTypeException = "UnsupportedProviderTypeException"

	// ErrCodeUpdateOutOfSyncException for service response error code
	// "UpdateOutOfSyncException".
	//
	// The update is out of sync. Try syncing again.
	ErrCodeUpdateOutOfSyncException = "UpdateOutOfSyncException"
)

var exceptionFromCode = map[string]func(protocol.ResponseMetadata) error{
	"AccessDeniedException":                 newErrorAccessDeniedException,
	"ConcurrentModificationException":       newErrorConcurrentModificationException,
	"ConditionalCheckFailedException":       newErrorConditionalCheckFailedException,
	"ConflictException":                     newErrorConflictException,
	"InternalServerException":               newErrorInternalServerException,
	"InvalidInputException":                 newErrorInvalidInputException,
	"LimitExceededException":                newErrorLimitExceededException,
	"ResourceAlreadyExistsException":        newErrorResourceAlreadyExistsException,
	"ResourceNotFoundException":             newErrorResourceNotFoundException,
	"ResourceUnavailableException":          newErrorResourceUnavailableException,
	"RetryLatestCommitFailedException":      newErrorRetryLatestCommitFailedException,
	"SyncBlockerDoesNotExistException":      newErrorSyncBlockerDoesNotExistException,
	"SyncConfigurationStillExistsException": newErrorSyncConfigurationStillExistsException,
	"ThrottlingException":                   newErrorThrottlingException,
	"UnsupportedOperationException":         newErrorUnsupportedOperationException,
	"UnsupportedProviderTypeException":      newErrorUnsupportedProviderTypeException,
	"UpdateOutOfSyncException":              newErrorUpdateOutOfSyncException,
}
