// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package cognitoidentityprovider provides the client and types for making API
// requests to Amazon Cognito Identity Provider.
//
// With the Amazon Cognito user pools API, you can set up user pools and app
// clients, and authenticate users. To authenticate users from third-party identity
// providers (IdPs) in this API, you can link IdP users to native user profiles
// (https://docs.aws.amazon.com/cognito/latest/developerguide/cognito-user-pools-identity-federation-consolidate-users.html).
// Learn more about the authentication and authorization of federated users
// in the Using the Amazon Cognito user pools API and user pool endpoints (https://docs.aws.amazon.com/cognito/latest/developerguide/cognito-userpools-server-contract-reference.html).
//
// This API reference provides detailed information about API operations and
// object types in Amazon Cognito. At the bottom of the page for each API operation
// and object, under See Also, you can learn how to use it in an Amazon Web
// Services SDK in the language of your choice.
//
// Along with resource management operations, the Amazon Cognito user pools
// API includes classes of operations and authorization models for client-side
// and server-side user operations. For more information, see Using the Amazon
// Cognito native and OIDC APIs (https://docs.aws.amazon.com/cognito/latest/developerguide/user-pools-API-operations.html)
// in the Amazon Cognito Developer Guide.
//
// You can also start reading about the CognitoIdentityProvider client in the
// following SDK guides.
//
//   - Amazon Web Services Command Line Interface (https://docs.aws.amazon.com/cli/latest/reference/cognito-idp/index.html#cli-aws-cognito-idp)
//
//   - Amazon Web Services SDK for .NET (https://docs.aws.amazon.com/sdkfornet/v3/apidocs/items/CognitoIdentityProvider/TCognitoIdentityProviderClient.html)
//
//   - Amazon Web Services SDK for C++ (https://sdk.amazonaws.com/cpp/api/LATEST/aws-cpp-sdk-cognito-idp/html/class_aws_1_1_cognito_identity_provider_1_1_cognito_identity_provider_client.html)
//
//   - Amazon Web Services SDK for Go (https://docs.aws.amazon.com/sdk-for-go/api/service/cognitoidentityprovider/#CognitoIdentityProvider)
//
//   - Amazon Web Services SDK for Java V2 (https://sdk.amazonaws.com/java/api/latest/software/amazon/awssdk/services/cognitoidentityprovider/CognitoIdentityProviderClient.html)
//
//   - Amazon Web Services SDK for JavaScript (https://docs.aws.amazon.com/AWSJavaScriptSDK/latest/AWS/CognitoIdentityServiceProvider.html)
//
//   - Amazon Web Services SDK for PHP V3 (https://docs.aws.amazon.com/aws-sdk-php/v3/api/api-cognito-idp-2016-04-18.html)
//
//   - Amazon Web Services SDK for Python (https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/cognito-idp.html)
//
//   - Amazon Web Services SDK for Ruby V3 (https://docs.aws.amazon.com/sdk-for-ruby/v3/api/Aws/CognitoIdentityProvider/Client.html)
//
// To get started with an Amazon Web Services SDK, see Tools to Build on Amazon
// Web Services (http://aws.amazon.com/developer/tools/). For example actions
// and scenarios, see Code examples for Amazon Cognito Identity Provider using
// Amazon Web Services SDKs (https://docs.aws.amazon.com/cognito/latest/developerguide/service_code_examples_cognito-identity-provider.html).
//
// See https://docs.aws.amazon.com/goto/WebAPI/cognito-idp-2016-04-18 for more information on this service.
//
// See cognitoidentityprovider package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/cognitoidentityprovider/
//
// # Using the Client
//
// To contact Amazon Cognito Identity Provider with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Amazon Cognito Identity Provider client CognitoIdentityProvider for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/cognitoidentityprovider/#New
package cognitoidentityprovider
