// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package dataexchange provides the client and types for making API
// requests to AWS Data Exchange.
//
// AWS Data Exchange is a service that makes it easy for AWS customers to exchange
// data in the cloud. You can use the AWS Data Exchange APIs to create, update,
// manage, and access file-based data set in the AWS Cloud.
//
// As a subscriber, you can view and access the data sets that you have an entitlement
// to through a subscription. You can use the APIs to download or copy your
// entitled data sets to Amazon Simple Storage Service (Amazon S3) for use across
// a variety of AWS analytics and machine learning services.
//
// As a provider, you can create and manage your data sets that you would like
// to publish to a product. Being able to package and provide your data sets
// into products requires a few steps to determine eligibility. For more information,
// visit the AWS Data Exchange User Guide.
//
// A data set is a collection of data that can be changed or updated over time.
// Data sets can be updated using revisions, which represent a new version or
// incremental change to a data set. A revision contains one or more assets.
// An asset in AWS Data Exchange is a piece of data that can be stored as an
// Amazon S3 object, Redshift datashare, API Gateway API, AWS Lake Formation
// data permission, or Amazon S3 data access. The asset can be a structured
// data file, an image file, or some other data file. Jobs are asynchronous
// import or export operations used to create or copy assets.
//
// See https://docs.aws.amazon.com/goto/WebAPI/dataexchange-2017-07-25 for more information on this service.
//
// See dataexchange package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/dataexchange/
//
// # Using the Client
//
// To contact AWS Data Exchange with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS Data Exchange client DataExchange for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/dataexchange/#New
package dataexchange
