// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package detective

import (
	"github.com/aws/aws-sdk-go/private/protocol"
)

const (

	// ErrCodeAccessDeniedException for service response error code
	// "AccessDeniedException".
	//
	// The request issuer does not have permission to access this resource or perform
	// this operation.
	ErrCodeAccessDeniedException = "AccessDeniedException"

	// ErrCodeConflictException for service response error code
	// "ConflictException".
	//
	// The request attempted an invalid action.
	ErrCodeConflictException = "ConflictException"

	// ErrCodeInternalServerException for service response error code
	// "InternalServerException".
	//
	// The request was valid but failed because of a problem with the service.
	ErrCodeInternalServerException = "InternalServerException"

	// ErrCodeResourceNotFoundException for service response error code
	// "ResourceNotFoundException".
	//
	// The request refers to a nonexistent resource.
	ErrCodeResourceNotFoundException = "ResourceNotFoundException"

	// ErrCodeServiceQuotaExceededException for service response error code
	// "ServiceQuotaExceededException".
	//
	// This request cannot be completed for one of the following reasons.
	//
	//    * The request would cause the number of member accounts in the behavior
	//    graph to exceed the maximum allowed. A behavior graph cannot have more
	//    than 1200 member accounts.
	//
	//    * The request would cause the data rate for the behavior graph to exceed
	//    the maximum allowed.
	//
	//    * Detective is unable to verify the data rate for the member account.
	//    This is usually because the member account is not enrolled in Amazon GuardDuty.
	ErrCodeServiceQuotaExceededException = "ServiceQuotaExceededException"

	// ErrCodeTooManyRequestsException for service response error code
	// "TooManyRequestsException".
	//
	// The request cannot be completed because too many other requests are occurring
	// at the same time.
	ErrCodeTooManyRequestsException = "TooManyRequestsException"

	// ErrCodeValidationException for service response error code
	// "ValidationException".
	//
	// The request parameters are invalid.
	ErrCodeValidationException = "ValidationException"
)

var exceptionFromCode = map[string]func(protocol.ResponseMetadata) error{
	"AccessDeniedException":         newErrorAccessDeniedException,
	"ConflictException":             newErrorConflictException,
	"InternalServerException":       newErrorInternalServerException,
	"ResourceNotFoundException":     newErrorResourceNotFoundException,
	"ServiceQuotaExceededException": newErrorServiceQuotaExceededException,
	"TooManyRequestsException":      newErrorTooManyRequestsException,
	"ValidationException":           newErrorValidationException,
}
