// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package medicalimaging provides the client and types for making API
// requests to AWS Health Imaging.
//
// This is the AWS HealthImaging API Reference. AWS HealthImaging is a HIPAA-eligible
// service that helps health care providers and their medical imaging ISV partners
// store, transform, and apply machine learning to medical images. For an introduction
// to the service, see the AWS HealthImaging Developer Guide (https://docs.aws.amazon.com/healthimaging/latest/devguide/what-is.html).
//
// We recommend using one of the AWS Software Development Kits (SDKs) for your
// programming language, as they take care of request authentication, serialization,
// and connection management. For more information, see Tools to build on AWS
// (http://aws.amazon.com/developer/tools).
//
// For information about using HealthImaging API actions in one of the language-specific
// AWS SDKs, refer to the See Also link at the end of each section that describes
// an API action or data type.
//
// The following sections list AWS HealthImaging API actions categorized according
// to functionality. Links are provided to actions within this Reference, along
// with links back to corresponding sections in the AWS HealthImaging Developer
// Guide where you can view console procedures and CLI/SDK code examples.
//
// Data store actions
//
//   - CreateDatastore (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_CreateDatastore.html)
//     – See Creating a data store (https://docs.aws.amazon.com/healthimaging/latest/devguide/create-data-store.html).
//
//   - GetDatastore (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_GetDatastore.html)
//     – See Getting data store properties (https://docs.aws.amazon.com/healthimaging/latest/devguide/get-data-store.html).
//
//   - ListDatastores (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_ListDatastores.html)
//     – See Listing data stores (https://docs.aws.amazon.com/healthimaging/latest/devguide/list-data-stores.html).
//
//   - DeleteDatastore (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_DeleteDatastore.html)
//     – See Deleting a data store (https://docs.aws.amazon.com/healthimaging/latest/devguide/delete-data-store.html).
//
// Import job actions
//
//   - StartDICOMImportJob (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_StartDICOMImportJob.html)
//     – See Starting an import job (https://docs.aws.amazon.com/healthimaging/latest/devguide/start-dicom-import-job.html).
//
//   - GetDICOMImportJob (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_GetDICOMImportJob.html)
//     – See Getting import job properties (https://docs.aws.amazon.com/healthimaging/latest/devguide/get-dicom-import-job.html).
//
//   - ListDICOMImportJobs (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_ListDICOMImportJobs.html)
//     – See Listing import jobs (https://docs.aws.amazon.com/healthimaging/latest/devguide/list-dicom-import-jobs.html).
//
// Image set access actions
//
//   - SearchImageSets (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_SearchImageSets.html)
//     – See Searching image sets (https://docs.aws.amazon.com/healthimaging/latest/devguide/search-image-sets.html).
//
//   - GetImageSet (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_GetImageSet.html)
//     – See Getting image set properties (https://docs.aws.amazon.com/healthimaging/latest/devguide/get-image-set-properties.html).
//
//   - GetImageSetMetadata (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_GetImageSetMetadata.html)
//     – See Getting image set metadata (https://docs.aws.amazon.com/healthimaging/latest/devguide/get-image-set-metadata.html).
//
//   - GetImageFrame (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_GetImageFrame.html)
//     – See Getting image set pixel data (https://docs.aws.amazon.com/healthimaging/latest/devguide/get-image-frame.html).
//
// Image set modification actions
//
//   - ListImageSetVersions (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_ListImageSetVersions.html)
//     – See Listing image set versions (https://docs.aws.amazon.com/healthimaging/latest/devguide/list-image-set-versions.html).
//
//   - UpdateImageSetMetadata (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_UpdateImageSetMetadata.html)
//     – See Updating image set metadata (https://docs.aws.amazon.com/healthimaging/latest/devguide/update-image-set-metadata.html).
//
//   - CopyImageSet (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_CopyImageSet.html)
//     – See Copying an image set (https://docs.aws.amazon.com/healthimaging/latest/devguide/copy-image-set.html).
//
//   - DeleteImageSet (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_DeleteImageSet.html)
//     – See Deleting an image set (https://docs.aws.amazon.com/healthimaging/latest/devguide/delete-image-set.html).
//
// Tagging actions
//
//   - TagResource (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_TagResource.html)
//     – See Tagging a data store (https://docs.aws.amazon.com/healthimaging/latest/devguide/tag-list-untag-data-store.html)
//     and Tagging an image set (https://docs.aws.amazon.com/healthimaging/latest/devguide/tag-list-untag-image-set.html).
//
//   - ListTagsForResource (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_ListTagsForResource.html)
//     – See Tagging a data store (https://docs.aws.amazon.com/healthimaging/latest/devguide/tag-list-untag-data-store.html)
//     and Tagging an image set (https://docs.aws.amazon.com/healthimaging/latest/devguide/tag-list-untag-image-set.html).
//
//   - UntagResource (https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_UntagResource.html)
//     – See Tagging a data store (https://docs.aws.amazon.com/healthimaging/latest/devguide/tag-list-untag-data-store.html)
//     and Tagging an image set (https://docs.aws.amazon.com/healthimaging/latest/devguide/tag-list-untag-image-set.html).
//
// See https://docs.aws.amazon.com/goto/WebAPI/medical-imaging-2023-07-19 for more information on this service.
//
// See medicalimaging package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/medicalimaging/
//
// # Using the Client
//
// To contact AWS Health Imaging with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS Health Imaging client MedicalImaging for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/medicalimaging/#New
package medicalimaging
