// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package ssoadmin provides the client and types for making API
// requests to AWS Single Sign-On Admin.
//
// IAM Identity Center (successor to Single Sign-On) helps you securely create,
// or connect, your workforce identities and manage their access centrally across
// Amazon Web Services accounts and applications. IAM Identity Center is the
// recommended approach for workforce authentication and authorization in Amazon
// Web Services, for organizations of any size and type.
//
// IAM Identity Center uses the sso and identitystore API namespaces.
//
// This reference guide provides information on single sign-on operations which
// could be used for access management of Amazon Web Services accounts. For
// information about IAM Identity Center features, see the IAM Identity Center
// User Guide (https://docs.aws.amazon.com/singlesignon/latest/userguide/what-is.html).
//
// Many operations in the IAM Identity Center APIs rely on identifiers for users
// and groups, known as principals. For more information about how to work with
// principals and principal IDs in IAM Identity Center, see the Identity Store
// API Reference (https://docs.aws.amazon.com/singlesignon/latest/IdentityStoreAPIReference/welcome.html).
//
// Amazon Web Services provides SDKs that consist of libraries and sample code
// for various programming languages and platforms (Java, Ruby, .Net, iOS, Android,
// and more). The SDKs provide a convenient way to create programmatic access
// to IAM Identity Center and other Amazon Web Services services. For more information
// about the Amazon Web Services SDKs, including how to download and install
// them, see Tools for Amazon Web Services (http://aws.amazon.com/tools/).
//
// See https://docs.aws.amazon.com/goto/WebAPI/sso-admin-2020-07-20 for more information on this service.
//
// See ssoadmin package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/ssoadmin/
//
// # Using the Client
//
// To contact AWS Single Sign-On Admin with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS Single Sign-On Admin client SSOAdmin for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/ssoadmin/#New
package ssoadmin
