// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package xray

import (
	"github.com/aws/aws-sdk-go/private/protocol"
)

const (

	// ErrCodeInvalidPolicyRevisionIdException for service response error code
	// "InvalidPolicyRevisionIdException".
	//
	// A policy revision id was provided which does not match the latest policy
	// revision. This exception is also if a policy revision id of 0 is provided
	// via PutResourcePolicy and a policy with the same name already exists.
	ErrCodeInvalidPolicyRevisionIdException = "InvalidPolicyRevisionIdException"

	// ErrCodeInvalidRequestException for service response error code
	// "InvalidRequestException".
	//
	// The request is missing required parameters or has invalid parameters.
	ErrCodeInvalidRequestException = "InvalidRequestException"

	// ErrCodeLockoutPreventionException for service response error code
	// "LockoutPreventionException".
	//
	// The provided resource policy would prevent the caller of this request from
	// calling PutResourcePolicy in the future.
	ErrCodeLockoutPreventionException = "LockoutPreventionException"

	// ErrCodeMalformedPolicyDocumentException for service response error code
	// "MalformedPolicyDocumentException".
	//
	// Invalid policy document provided in request.
	ErrCodeMalformedPolicyDocumentException = "MalformedPolicyDocumentException"

	// ErrCodePolicyCountLimitExceededException for service response error code
	// "PolicyCountLimitExceededException".
	//
	// Exceeded the maximum number of resource policies for a target Amazon Web
	// Services account.
	ErrCodePolicyCountLimitExceededException = "PolicyCountLimitExceededException"

	// ErrCodePolicySizeLimitExceededException for service response error code
	// "PolicySizeLimitExceededException".
	//
	// Exceeded the maximum size for a resource policy.
	ErrCodePolicySizeLimitExceededException = "PolicySizeLimitExceededException"

	// ErrCodeResourceNotFoundException for service response error code
	// "ResourceNotFoundException".
	//
	// The resource was not found. Verify that the name or Amazon Resource Name
	// (ARN) of the resource is correct.
	ErrCodeResourceNotFoundException = "ResourceNotFoundException"

	// ErrCodeRuleLimitExceededException for service response error code
	// "RuleLimitExceededException".
	//
	// You have reached the maximum number of sampling rules.
	ErrCodeRuleLimitExceededException = "RuleLimitExceededException"

	// ErrCodeThrottledException for service response error code
	// "ThrottledException".
	//
	// The request exceeds the maximum number of requests per second.
	ErrCodeThrottledException = "ThrottledException"

	// ErrCodeTooManyTagsException for service response error code
	// "TooManyTagsException".
	//
	// You have exceeded the maximum number of tags you can apply to this resource.
	ErrCodeTooManyTagsException = "TooManyTagsException"
)

var exceptionFromCode = map[string]func(protocol.ResponseMetadata) error{
	"InvalidPolicyRevisionIdException":  newErrorInvalidPolicyRevisionIdException,
	"InvalidRequestException":           newErrorInvalidRequestException,
	"LockoutPreventionException":        newErrorLockoutPreventionException,
	"MalformedPolicyDocumentException":  newErrorMalformedPolicyDocumentException,
	"PolicyCountLimitExceededException": newErrorPolicyCountLimitExceededException,
	"PolicySizeLimitExceededException":  newErrorPolicySizeLimitExceededException,
	"ResourceNotFoundException":         newErrorResourceNotFoundException,
	"RuleLimitExceededException":        newErrorRuleLimitExceededException,
	"ThrottledException":                newErrorThrottledException,
	"TooManyTagsException":              newErrorTooManyTagsException,
}
